<?php

namespace Teknisa\PED\Modules\Expedicao\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request\Filter;

class Exp00600RelatorioConsumoExpedicaoController extends \Teknisa\PED\Controllers\TeknisaCrud {

    protected $crudService;
    protected $dataSourceName = 'relatorio_consumo_na_expedicao';
   // protected $dataSourceNameToSave = 'transport';
    protected $environment;
    protected $parameterBagColumns;

    public function __construct($crudService, $parameterBag, $environment) {
        parent::__construct($crudService, $parameterBag);
        $this->crudService = $crudService;
        $this->environment = $environment;
    }
    
    public function findRelatorio(DTO\Request\Filter $request, DTO\Response $response) {
        
        /*
            Redefinição dos parâmetros criando um novo Request
            e também
            incrementando paramâmetros na parameterbagColumns
        */
        
        // Aquisição do parametro 'filter' da velha Requisição
        $parametersFilter = $request->getParameters()['filter'];
        
        // Aquisiçao dos parametros da velha Requisição
        $parametersPersist = $request->getParameters();
        unset($parametersPersist['filter']);
        
        $conditions = array();
        
        foreach ($parametersFilter as &$parameter) {
            
            if (substr($parameter['name'],0,2) === 'P_') {
            
                // para cada parâmetro P_ será inserido no parameterbagColumns
                $this->parameterBagColumns[] = $parameter['name'];
                
                // geralmente P_PRODFIM vem sem 'value' e é necessário definir para dar erro no backend
                if ($parameter['name'] == 'P_PRODFIM') {
                    $parameter['value'] = null;     
                }
                
                // Transferencia de valores em um novo Conditions para o novo FilterCriteria
                $conditions[] = array(
                        
                        "columnName"    => $parameter['name'],
                        "operator"      => $parameter['operator'],
                        "value"         => $parameter['value']
                        
                        );
            
            } else {
                
             // Busca e Exclusão de parãmetros repetidos
             $index = array_search($parameter, $parametersFilter);
             unset($parametersFilter[$index]);
                
            }
            
            
        }
        
        $newRequest = new Filter(
            new FilterCriteria($this->dataSourceName,$conditions),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        
        // Transferindo valores do velho Request para o Novo Request
        foreach($parametersPersist as $paramKey => $persist) {
            
            $newRequest->setParameter($paramKey,$persist);
            
        }
        
        // Setando valor de filter configurado para o novo Request
        $newRequest->setParameter('filter',$parametersFilter);
        
        // Busca normal pelo filtro e pela widget principal(relatorio_consumo_na_expedicao)
        parent::find($newRequest, $response);
        
    }

    

}